import { snippetCompletion } from '@codemirror/autocomplete';
import { LRLanguage, StreamLanguage, indentNodeProp, delimitedIndent, foldNodeProp, foldInside, LanguageSupport, syntaxHighlighting } from '@codemirror/language';
import { jinja2 } from '@codemirror/legacy-modes/mode/jinja2';
import { parseMixed } from '@lezer/common';
import { styleTags, tags, classHighlighter } from '@lezer/highlight';
import { vscodeDarkInit } from '@uiw/codemirror-theme-vscode';
import { LRParser } from '@lezer/lr';

// This file was generated by lezer-generator. You probably shouldn't edit it.
const parser = LRParser.deserialize({
  version: 14,
  states: "0OQ]QPOOOqQQO'#CbOvQQO'#CuO{QQO'#CwO!QQQO'#DQO!VQQO'#DRO![QQO'#DSOOQO'#C`'#C`OOQO'#DT'#DTQ]QPOOO!aQPO,58|O!fQPO,59aO!kQPO,59cO!pQPO,59lO!uQPO,59mO!zQPO,59nOOQO-E7R-E7RO#PQQO1G.hO#[QQO1G.{O#gQQO1G.}O#oQQO1G/WO#gQQO1G/XO#wQQO1G/YO$PQQO'#CeO$UQQO'#CkOOQO'#DU'#DUO$aQQO7+$SOOQO7+$S7+$SO$lQQO'#CvOOQO'#DX'#DXO$zQQO7+$gOOQO7+$g7+$gO%VQPO'#CyO%[QPO'#CxO%dQQO'#CxO%lQPO7+$iO%qQSO'#CzOOQO'#DZ'#DZO&SQQO7+$rOOQO7+$r7+$rO&[QPO7+$sO&aQQO7+$tOOQO7+$t7+$tO&iQPO,59PO&nQQO,59VO'PQQO'#ClO'hQPO'#CrOOQO'#Co'#CoO$UQQO'#CmOOQO'#Cm'#CmOOQO'#Cl'#ClOOQO-E7S-E7SOOQO<<Gn<<GnO'mQQO'#CtOOQO'#DW'#DWO'rQQO,59bOOQO-E7V-E7VOOQO<<HR<<HRO$UQQO,59eOOQO,59t,59tO(QQPO,59dOOQO-E7W-E7WO(YQPO<<HTOOQO'#C|'#C|O(_OWO'#DPOOQO'#C{'#C{O(gQQO'#C{OOQO,59f,59fOOQO-E7X-E7XOOQO<<H^<<H^O%}QPO<<H_OOQO<<H`<<H`O(oO`O'#CfOOQO1G.k1G.kO$UQQO,59YO(}QQO1G.qOOQO,59[,59[OOQO,59],59]O$UQQO,59^O)]QPO'#CnO)bQPO'#ClO)vQPO,59XO&iQPO,59`OOQO-E7U-E7UO*OQPO1G/PP*ZQPO'#DYO$UQQOAN=oOOOO'#DV'#DVO*`OWO'#CjO*hOPO,59kOOQO,59g,59gO*mQQO,59gOOQOAN=yAN=yO(_OWO'#CiOOQO,59Q,59QO*uOPO,59QOOQO1G.t1G.tO*zQPO1G.xOOQO1G.s1G.sOOQO1G.z1G.zO+VQPOG23ZOOOO-E7T-E7TOOQO1G/V1G/VOOQO1G/R1G/RO+_OPO,59TOOQO1G.l1G.lO$UQQO7+$dO+dQQOLD(uOOOO1G.o1G.oO+lQPO<<HOO+wQQO!$'LaOOQO!$'La!$'LaOOQOAN=jAN=jOOQO!)9A{!)9A{O$UQQO,59Y",
  stateData: ",W~O!QOSPOSQOS~O!RPO!aQO!bRO!eSO!fTO!gUO~OVYO~OVZO~OV[O~OV]O~OV^O~OV_O~OWaO~OWbO~O!UcO~OWdO~O!UeO~OWfO~OTkOVhO!SgO~OToOVlO!SgO~OVpO!TlP~OTwOVtO~OTzOVtO~OV{O~OV!POg!OO!U!QO~OT!UOVhO!SgO~O!`!VOTjXVjX!SjX~OT!ZOVlO!SgO~O!c![O~O!_!]O!TlX~OVpO!TlX~O!T!`O~OW!dOZ!aOq!aOr!aO!W!bO~OT!gOVtO~O!T!hO~OT!iOVtO~O!U!jO~O!Y!lO!`!VOT_aV_a!S_a~O!Z!nO![!oOT`XV`X!S`X!Y`X!``X~O!^!pO~OV!tO~O!`!VOTjaVja!Sja~O!_!]O!Tla~O!d!xO~O!X!yO!V^P~OT!|OVtO~OZ#RO[#RO!T#QO!W#PO~O!`!VOT_iV_i!S_i~O!Y#fO~O!Z!nO![!oO!Y`X!T`X!_`XW`X~O!T#UO!Y`X~O!Y#fO!Tmi!_mi~O!_!]O~O!X!yO!V^X~O!V#YO~OT#ZOVtO~O!T#]O~O!Z!nO![!oO!_#^O~OW#_O!Y#fO~O!V#`O~OT#cOVtO~O!Z!nO![!oO!]#dO~OT#eOVtO~OqZgVr[~",
  goto: "&_!OPPPP!PP!TPP!X!aPP!g!j!p!t#U#f#p#z#z#zP$U!T!]!T$[$b$i$s$vPP$y!T!T!T%P%V%]%d%n%t%{TWOXTVOXSiajTmbnQ!k{R#V!tR#R!jQ!{!bR#[#PTiajQ|hQ!q!QQ!v![S#S!l#fR#W!xS}h!lW!r!Q![!x#fQ#T!pR#a#^Y!Sh![!l!x#fR!s!Qa!Rh!Q![!l!p!x#^#fa!Ph!Q![!l!p!x#^#fX!Wl|!X!mQscRxeSqceR!^raudfvy!d!}#_#bR!etR!ctQ!ctR#O!hQXOR`XQjaR!TjS!z!b#PR#X!zQ!XlQ!m|T!u!X!mQnbR!YnSrceR!_rQvdQyfW!fvy!}#bQ!}!dR#b#_",
  nodeNames: "⚠ MultilineComment TrailingComment Baml Decl } ClassDecl IdentifierDecl { BlockAttribute AttributeValue QuotedString UnquotedAttributeValue PromptExprNonJinja PromptExprContents ClassField TypeExpr ComplexTypeExpr UnionTypeExpr SimpleTypeExpr ListTypeExpr OptionalTypeExpr MapTypeExpr MapIdentifier FieldAttribute EnumDecl EnumValueDecl FunctionDecl FunctionArgs FunctionArg TupleValue ValueExpr LiteralDecl NumericLiteral UnquotedString PromptExpr ClientDecl TemplateStringDecl TestDecl",
  maxTerm: 69,
  skippedNodes: [0,1,2],
  repeatNodeCount: 7,
  tokenData: "#LqoR!SOX$_XY(jYZ(jZ]$_]^(j^p$_pq(qqr$_rs*SstG`tw$_wxGmxyGryzGyz|$_|}HQ}!OHX!O!PKu!P!QNo!Q![! `![!]!&[!]!^$_!^!_!'o!_!`$_!`!a!'v!a!b!'}!b!c!)b!c!}!)q!}#O!+e#O#P$_#P#QGm#Q#R$_#R#S!)q#S#T$_#T#V!)q#V#W!+r#W#X!)q#X#Y!<s#Y#Z!DP#Z#a!)q#a#b#$k#b#h!)q#h#i#)|#i#o!)q#o#p#Hu#p#q#KP#q#r#Ld#r;'S$_;'S;=`#Lk<%lO$_l$hb!XWrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pd%wbrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%p`'Ub[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q!^'P!_!`'P!a!b'P!c!}'P#O#P'P#Q#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'P`(aP;=`<%l'Pd(gP;=`<%l%p_(qO!XW!QVo(zb!XW!QV[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q!^'P!_!`'P!a!b'P!c!}'P#O#P'P#Q#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pm*]n!XWrS[`OX%pZ]%p^p%ppq,Zqr:krs<pstFqtw:kwz/mz|:k|}/m}!P:k!P!Q/m!Q!^:k!^!_/m!_!`:k!`!a/m!a!b:k!b!c/m!c!}:k!}#O/m#O#P>R#P#Q/m#Q#o:k#o#p/m#p#q:k#q#r/m#r;'S:k;'S;=`Fk<%lO:kd,`n[`OX'PZ]'P^p'Ppq,Zqr,Zrs.^st/mtw,Zwz/mz|,Z|}/m}!P,Z!P!Q/m!Q!^,Z!^!_/m!_!`,Z!`!a/m!a!b,Z!b!c/m!c!},Z!}#O/m#O#P2V#P#Q/m#Q#o,Z#o#p/m#p#q,Z#q#r/m#r;'S,Z;'S;=`:e<%lO,Zd.ebZd[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q!^'P!_!`'P!a!b'P!c!}'P#O#P'P#Q#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd/pWpq/mqr/mrs0Ys#O/m#O#P0_#P;'S/m;'S;=`2P<%lO/md0_OZdd0bXrs/m!P!Q/m#O#P/m#U#V/m#Y#Z/m#b#c/m#f#g/m#h#i/m#i#j0}d1QR!Q![1Z!c!i1Z#T#Z1Zd1^R!Q![1g!c!i1g#T#Z1gd1jR!Q![1s!c!i1s#T#Z1sd1vR!Q![/m!c!i/m#T#Z/md2SP;=`<%l/md2[o[`OX'PZ]'P^p'Ppq'Pqr'Prs,Ztw'Pz|'P}!P'P!P!Q/m!Q!^'P!_!`'P!a!b'P!c!}'P#O#P,Z#Q#U'P#U#V,Z#V#Y'P#Y#Z,Z#Z#b'P#b#c,Z#c#f'P#f#g,Z#g#h'P#h#i,Z#i#j4]#j#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd4bf[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q![5v![!^'P!_!`'P!a!b'P!c!i5v!i!}'P#O#P'P#Q#T'P#T#Z5v#Z#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd5{f[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q![7a![!^'P!_!`'P!a!b'P!c!i7a!i!}'P#O#P'P#Q#T'P#T#Z7a#Z#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd7ff[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q![8z![!^'P!_!`'P!a!b'P!c!i8z!i!}'P#O#P'P#Q#T'P#T#Z8z#Z#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd9Pf[`OX'PZ]'P^p'Ppq'Pqs'Ptw'Pz|'P}!P'P!Q![,Z![!^'P!_!`'P!a!b'P!c!i,Z!i!}'P#O#P'P#Q#T'P#T#Z,Z#Z#o'P#p#q'P#r;'S'P;'S;=`(^<%lO'Pd:hP;=`<%l,Zd:rnrS[`OX%pZ]%p^p%ppq,Zqr:krs<pst/mtw:kwz/mz|:k|}/m}!P:k!P!Q/m!Q!^:k!^!_/m!_!`:k!`!a/m!a!b:k!b!c/m!c!}:k!}#O/m#O#P>R#P#Q/m#Q#o:k#o#p/m#p#q:k#q#r/m#r;'S:k;'S;=`Fk<%lO:kd<ybZdrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pd>YorS[`OX%pZ]%p^p%ppq'Pqr%prs:ktw%pz|%p}!P%p!P!Q/m!Q!^%p!_!`%p!a!b%p!c!}%p#O#P:k#Q#U%p#U#V:k#V#Y%p#Y#Z:k#Z#b%p#b#c:k#c#f%p#f#g:k#g#h%p#h#i:k#i#j@Z#j#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pd@bfrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![Av![!^%p!_!`%p!a!b%p!c!iAv!i!}%p#O#P%p#Q#T%p#T#ZAv#Z#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdA}frS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![Cc![!^%p!_!`%p!a!b%p!c!iCc!i!}%p#O#P%p#Q#T%p#T#ZCc#Z#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdCjfrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![EO![!^%p!_!`%p!a!b%p!c!iEO!i!}%p#O#P%p#Q#T%p#T#ZEO#Z#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdEVfrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![:k![!^%p!_!`%p!a!b%p!c!i:k!i!}%p#O#P%p#Q#T%p#T#Z:k#Z#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdFnP;=`<%l:kmFvW!VXpq/mqr/mrs0Ys#O/m#O#P0_#P;'S/m;'S;=`2P<%lO/mmGeP!XWrsGheGmO!WeWGrO!XWZGyO!UR!XWkHQO!Tc!XWXHXO!_P!XWoHdh!XWVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!`!aKp!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pfJXgVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pPKuO!dPlLOc!XWrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![MZ![!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pdMdcqSrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![MZ![!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%p_NtP!XW!P!QNwVN|SQVOYNwZ;'SNw;'S;=`! Y<%lONwV! ]P;=`<%lNwn! mg!XWqSVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P!#U!Q![!$h![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pd!#]crS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q![MZ![!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pf!$sgqSVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P!#U!Q![!$h![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pm!&gb!cP!XWrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pX!'vO!^P!XWX!'}O!]P!XWo!(Yb![R!XWrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pY!)iP!`Q!XW!b!c!)lQ!)qO!SQn!)|g!XWVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pZ!+jP!XW#P#Q!+mR!+rO!ZRo!+}i!XWVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#`JO#`#a!-l#a#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!-ujVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#U!/g#U#]JO#]#^!4y#^#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!/piVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#gJO#g#h!1_#h#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!1hiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#gJO#g#h!3V#h#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!3bg!RPVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!5SiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#XJO#X#Y!6q#Y#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!6ziVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c!8i#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!8riVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i!:a#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!:jhVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!^!_!<U!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pP!<XP#`#a!<[P!<_P#`#a!<bP!<eP#a#b!<hP!<kP!`!a!<nP!<sO!ePo!=Oi!XWVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c!>m#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!>viVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#iJO#i#j!@e#j#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!@niVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#aJO#a#b!B]#b#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!Bhg!aPVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%po!D[i!XWVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#iJO#i#j!Ey#j#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!FSiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c!Gq#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!GziVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#VJO#V#W!Ii#W#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!IriVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i!Ka#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!KjiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#]JO#]#^!MX#^#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg!MbiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#cJO#c#d# P#d#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg# YiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c#!w#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg##Sg!bPVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pn#$vh!XWVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#U#&b#U#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pf#&kiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#dJO#d#e#(Y#e#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pf#(eggQVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%po#*Xi!XWVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#XJO#X#Y#+v#Y#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#,PkVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#aJO#a#b#-t#b#gJO#g#h#EZ#h#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#-}iVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#dJO#d#e#/l#e#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#/uiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#`JO#`#a#1d#a#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#1mhVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#U#3X#U#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#3biVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i#5P#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#5YiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#XJO#X#Y#6w#Y#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#7QgVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#S#8i#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#8riVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#gJO#g#h#:a#h#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#:jiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i#<X#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#<biVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#fJO#f#g#>P#g#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#>YiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#]JO#]#^#?w#^#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#@QiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#bJO#b#c#Ao#c#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#AxiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#ZJO#Z#[#Cg#[#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#Crg!fPVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#EdiVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#hJO#h#i#GR#i#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%pg#G^g!gPVQrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!OJO!O!P%p!Q![JO![!^%p!_!`%p!a!b%p!c!}JO#O#P%p#Q#R%p#R#SJO#S#T%p#T#oJO#p#q%p#r;'S%p;'S;=`(d<%lO%p_#H|PWT!XW!P!Q#IPV#ISP!P!Q#IVV#IYTO!P#IV!P!Q#Ii!Q;'S#IV;'S;=`#Jy<%lO#IVV#IlTO!P#IV!P!Q#I{!Q;'S#IV;'S;=`#Jy<%lO#IVV#JOVO!P#IV!P!Q#I{!Q#q#IV#q#r#Je#r;'S#IV;'S;=`#Jy<%lO#IVV#JjTPVO!P#IV!P!Q#Ii!Q;'S#IV;'S;=`#Jy<%lO#IVV#J|P;=`<%l#IVo#K[b!YR!XWrS[`OX%pZ]%p^p%ppq'Pqs%ptw%pz|%p}!P%p!Q!^%p!_!`%p!a!b%p!c!}%p#O#P%p#Q#o%p#p#q%p#r;'S%p;'S;=`(d<%lO%pY#LkOTQ!XWl#LnP;=`<%l$_",
  tokenizers: [0, 1, 2, 3, 4],
  topRules: {"Baml":[0,3]},
  tokenPrec: 507
});

const BAMLLanguage = LRLanguage.define({
    parser: parser.configure({
        wrap: parseMixed((node) => {
            if (node.name !== 'PromptExprContents') {
                return null;
            }
            return {
                parser: StreamLanguage.define(jinja2).parser,
            };
        }),
        props: [
            indentNodeProp.add({
                Decl: delimitedIndent({ closing: '}', align: true }),
                // not sure the except is doing anything.
                PromptExpr: delimitedIndent({ closing: '#"', align: true }),
            }),
            foldNodeProp.add({
                ClassDecl: foldInside,
            }),
            styleTags({
                'Decl/*/"{" Decl/*/"}"': tags.brace,
                'ValueExpr/"{" ValueExpr/"}"': tags.brace,
                TestDecl: tags.keyword,
                'TestDecl/IdentifierDecl': tags.typeName,
                EnumDecl: tags.keyword,
                'EnumDecl/IdentifierDecl': tags.typeName,
                'EnumDecl/EnumValueDecl/IdentifierDecl': tags.propertyName,
                ClassDecl: tags.keyword,
                'ClassDecl/IdentifierDecl': tags.typeName,
                ClientDecl: tags.keyword,
                'ClientDecl/IdentifierDecl': tags.typeName,
                FunctionDecl: tags.keyword,
                'FunctionDecl/IdentifierDecl': tags.function(tags.variableName),
                'FunctionArg/IdentifierDecl': tags.variableName,
                'ClassField/IdentifierDecl': tags.propertyName,
                NumericLiteral: tags.number,
                QuotedString: tags.string,
                UnquotedString: tags.string,
                'AttributeValue/UnquotedAttributeValue': tags.string,
                FieldAttribute: tags.attributeName,
                'FieldAttribute/@': tags.attributeName,
                'FieldAttribute/IdentifierDecl': tags.attributeName,
                'BlockAttribute/@@': tags.attributeName,
                'BlockAttribute/IdentifierDecl': tags.attributeName,
                'SimpleTypeExpr/IdentifierDecl': tags.typeName,
                variable: tags.controlKeyword,
                PromptExpr: tags.string,
                'PromptExprNonJinja/...': tags.string,
                'PromptExprNonJinja/PromptExprContents/...': tags.operator,
                'TemplateStringDecl/IdentifierDecl': tags.attributeName,
                'TemplateStringDecl/PromptExpr': tags.string,
                'TupleValue/IdentifierDecl': tags.operator,
                TrailingComment: tags.comment,
                MultilineComment: tags.comment,
            }),
        ],
    }),
    languageData: {
        commentTokens: { line: '//' },
        closeBrackets: {
            brackets: ['(', '[', '"', '#"', '{'],
            stringPrefixes: ['#"'],
            wordChars: ['#', '"'],
        },
        snippetCompletion: true,
    },
});
const exampleCompletion = BAMLLanguage.data.of({
    autocomplete: [
        snippetCompletion('@alias(#"${one}"#)', { label: '@alias' }),
        snippetCompletion('@description(#"${}"#)', { label: '@description' }),
        snippetCompletion('class ${ClassName} {\n  ${property string}\n}', { label: 'class' }),
        snippetCompletion('enum ${EnumName} {\n  ${ONE}\n  ${TWO}\n}', { label: 'enum' }),
        snippetCompletion('function MyFunction(${arg: string}) -> ${YourOutputType} {\n  ${client YourClient}\n  prompt #"\n    ${add some instructions}\n  "#\n}', { label: 'function' }),
        snippetCompletion('prompt #"\n  {{ _.role("user") }}\n  INPUT:\n  ---\n  {{ your-variable }}\n  ---\n  Response:\n"#', { label: 'prompt #"' }),
        snippetCompletion('_.role("${role}")', { label: '_.role"' }),
        snippetCompletion('#"${mystring}"#', { label: '#"' }),
        snippetCompletion('client<llm> GPT4 {\n  provider baml-openai-chat\n  options {\n    model gpt4  \n}}', {
            label: 'client<llm> GPT4',
        }),
        snippetCompletion('template_string MyString(${arg1}: string) #"\n  A jinja string\n"#', {
            label: 'template_string',
        }),
    ],
});
const theme = vscodeDarkInit({
    styles: [
        {
            tag: [tags.variableName],
            color: '#dcdcaa',
        },
        {
            tag: [tags.brace],
            color: '#569cd6',
        },
        {
            tag: [tags.variableName, tags.propertyName],
            color: '#d4d4d4',
        },
        {
            tag: [tags.attributeName],
            color: '#c586c0',
        },
    ],
});
function BAML() {
    return new LanguageSupport(BAMLLanguage, [exampleCompletion, syntaxHighlighting(classHighlighter)]);
}

export { BAML, BAMLLanguage, theme };
